image: cirrusci/flutter:3.3.8


stages:
  - test
  - build
  - test_merge_request

test:

  only:
      - master


  stage: test
  script:
    - flutter pub get
    - flutter clean
    - flutter test

build:

  only:
      - master
      - tags

  stage: build

  before_script:
    - echo "$KEYSTORE" | base64 --decode > android/app/keystore.jks
    - echo "storeFile=keystore.jks" > android/key.properties
    - echo "storePassword=$KEYSTORE_PASSWORD" >> android/key.properties
    - echo "keyAlias=$ALIAS" >> android/key.properties
    - echo "keyPassword=$KEY_PASSWORD" >> android/key.properties

  script:
    - flutter pub get
    - flutter clean
    - flutter build appbundle
    - flutter build apk

  artifacts:
    paths:
    - build/app/outputs/bundle/release/app-release.aab
    - build/app/outputs/flutter-apk/app-release.apk

test_merge_request:
  
   stage: test_merge_request

   only:
      - merge_requests

   script:
      - flutter pub get
      - flutter clean
      - flutter test
      - flutter build apk --debug
   artifacts:
     paths:
      - build/app/outputs/flutter-apk/app-debug.apk
